"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateOpts = exports.getOpts = void 0;

var assert = _interopRequireWildcard(require("assert"));

var _fs = require("fs");

var _path = require("path");

var _lodash = require("lodash");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const getOpts = (opts, ctx) => {
  return (0, _lodash.merge)({
    cwd: ctx.cwd
  }, opts);
};

exports.getOpts = getOpts;

const validateOpts = (opts, ctx) => {
  const {
    cwd,
    runtimeHelpers,
    target
  } = opts;

  if (runtimeHelpers) {
    const pkg = getPkgFile({
      cwd
    });
    assert.ok((pkg.dependencies || {})["@babel/runtime"], "@babel/runtime dependency is required to use runtimeHelpers.");
  }

  if (target === "browser") {
    if (!(0, _fs.existsSync)((0, _path.join)(cwd, ".browserslistrc"))) {
      ctx.console.warn("No .browserslistrc found for browser target.");
    }
  }
};

exports.validateOpts = validateOpts;